#!/usr/bin/env python
# -*- coding: UTF-8 -*-

__authors__ = "joel"
__date__ = "avril 2008"

"""
Ajout/Suppression d'un compte mail
[ pour compatibilité EAD1 ]
"""

import sys
import getopt
from scribe import backend

def usage():
    """
    affichage de l'aide
    """
    print """  arguments:
                -u "uid de l'utilisateur"
                -p "mot de passe"
                [-d interne]
                [-m] (modification)
                [-r] (suppression)
                -h aide

  exemple : %s -u toto -p monpwd
  """ % sys.argv[0]

def main():
    """
    programmme principal
    """
    user = None
    password = None
    predomain = 'internet'
    remove = modif = 0
    # récupération des arguments de la ligne de commande
    try:
        options, args = getopt.getopt(sys.argv[1:], 'u:p:d:rmh', 
	                ['user=', 'password=', 'domain=', 'help'])

    except getopt.GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("l'option -%s est inconnue ou nécessite un argument" % 
                er_msg[er_msg.index('-')+1])

    for (opt, val) in options:
        if (opt == '-u') or (opt == '--user'):
            user = val
        elif (opt == '-p') or (opt == '--password'):
            password = val
        elif (opt == '-d') or (opt == '--domain'):
            if val == 'interne' :
                predomain = 'restreint'
        elif (opt == '-m'):
            modif = 1
        elif (opt == '-r'):
            remove = 1        
        elif (opt == '-h') or (opt == '--help'):
            usage()
            sys.exit(0)
    
    if user and remove == 1:
        # suppression de compte
        backend.del_mail(user)
        exit(0)
    
    if (not user) or (not password):
        usage()
        exit(0)

    if modif == 1:
        # changement de mot de passe
        res, msg = backend.mod_mail_password(user, password)
        if res:
            print "Le compte mail %s a été modifié." % user
            exit(0)
        print msg
        exit(1)
    else:
        # nouvel utilisateur
        res, msg = backend.ajout_mail(user, password, predomain)
        if res:
            print "Le compte mail %s a été ajouté." % user
            exit(0)
        print msg
        exit(1)


if __name__ == '__main__':
    main()
